package proto

const (
	ReqDisbandRoomId     = "ReqDisbandRoomId"     // 解散房间
	ReqUserDisbandRoomId = "ReqUserDisbandRoomId" // 成员申请解散房间
	RspUserDisbandRoomId = "RspUserDisbandRoomId" //
	NtfUserDisbandRoomId = "NtfUserDisbandRoomId"
)

// 解散房间
type ReqDisbandRoom struct {
	RoomId int `json:"r"` // 房间id
}

// 解散房间
type ReqUserDisbandRoom struct {
	RoomId int `json:"r"` // 房间id
	Type   int `json:"t"` // 解散类型 0:成员申请解散 1:管理员强制解散
	Agree  int `json:"a"` // 解散类型 0:不同意申请解散 1:同意解散 2:主动发起解散请求
}

// 解散房间
type RspUserDisbandRoom struct {
	Code   ErrorCode `json:"code"`
	RoomId int       `json:"r"` // 房间id
	Type   int       `json:"t"` // 解散类型 0:成员申请解散 1:管理员强制解散
}

type NtfUserDisbandRoom struct {
	RoomId      int     `json:"r"` // 房间id
	CountDown   int     `json:"c"` // cd
	CountDownEx int     `json:"d"`
	Type        int     `json:"t"` // 解散类型 0:成员申请解散 1:管理员强制解散
	Agree       []int64 `json:"p"` // 同意解散的人
	Against     []int64 `json:"a"` // 反对解散的人
	Initiator   int64   `json:"i"` // 发起人
}
