package cmd

import (
	"fmt"
	"os"
	"os/signal"
	"samba/pkg/log"
	"samba/server/club/handler"
	"samba/util/config"
	"syscall"
	"testing"
)

//var token = ""

// 初始化环境
func initEnv() {
	config.Cmd = config.Command{
		LogLevel:   -1,
		ConfigPath: "D:\\work\\samba\\samba\\bin\\config\\club_dev.xml",
	}
	initLog(&config.Cmd)
	var err = config.Load(config.Cmd.ConfigPath)
	if err != nil {
		log.Error(fmt.Sprintf("load config err: %v", err))
	}
	initRepo()

	handler.InitService()
}

// 释放环境
func releaseEnv() {
	c := make(chan os.Signal, 1)
	signal.Notify(c, syscall.SIGINT, syscall.SIGTERM)
	sig := <-c
	handler.StopService()
	log.Info(fmt.Sprintf("received %s, initiating shutdown...\n", sig))
}

// 清理所有玩家的携带脏数据
func TestCleanTakeCoin(t *testing.T) {
	initEnv()

	releaseEnv()
}
