package baseroom

type TimerType int

const (
	DisbandRoomCd = 10 // 解散房间10秒
)

const (
	TtUnknown TimerType = 0

	TtDealPoker      TimerType = 200 // 发牌结束后通知玩家行动
	TtDecidingGame   TimerType = 201 // 决胜局展示手牌及同意，放弃行动
	TtPlayerAct      TimerType = 202 // 玩家行动
	TtPlayerRspRaise TimerType = 204 // 玩家回应行动
	TtCmpPoker       TimerType = 205 // 比牌
	TtNextGame       TimerType = 208 // 下一小局
	//TtGameEnd        TimerType = 205 // 大局结束，询问玩家是否继续
	//TtContinue       TimerType = 206 // 继续
	TtSecond         TimerType = 220 // 每秒定时器
	TtGameReadyStart TimerType = 221 // 游戏开始倒计时
	TtEnterRoom      TimerType = 222
	TtEmote          TimerType = 223 // 发送表情

	TtPlayerCutLine      TimerType = 401 // 插队
	TtDelDisbandRoomInfo TimerType = 402 // 删除解散房间投票
)

func (t TimerType) String() string {
	switch t {
	case TtDealPoker:
		return "TtDealPoker"
	case TtDecidingGame:
		return "TtDecidingGame"
	case TtPlayerAct:
		return "TtPlayerAct"
	case TtPlayerRspRaise:
		return "TtPlayerRspRaise"
	case TtCmpPoker:
		return "TtCmpPoker"
	case TtNextGame:
		return "TtNextGame"
	case TtPlayerCutLine:
		return "TtPlayerCutLine"
	//case TtContinue:
	//	return "TtContinue"
	//case TtWaitRobot:
	//	return "TtWaitRobot"
	case TtGameReadyStart:
		return "TtGameReadyStart"
	case TtDelDisbandRoomInfo:
		return "TtDelDisbandRoomInfo"
	case TtEnterRoom:
		return "TtEnterRoom"
	}
	return ""
}
