package poker

import . "samba/util/playtype"

type PlayTypeConst struct {
	playType PlayType
}

func NewPlayTypeConst(playType PlayType) *PlayTypeConst {
	return &PlayTypeConst{playType: playType}
}

// 游戏刚开始初始分为2点
func (t *PlayTypeConst) GameStartPoint() int {
	switch t.playType {
	case PtPaulistaClean:
		return 1
	case PtPaulistaDirty:
		return 1
	case PtMineiroClean:
		return 2
	case PtMineiroDirty:
		return 2
	default:
		return 0
	}
}

// 后续加点
func (t *PlayTypeConst) NextPoint(curPoint int) int {
	switch t.playType {
	case PtPaulistaClean, PtPaulistaDirty:
		switch curPoint {
		case 1:
			return 3
		case 3:
			return 6
		case 6:
			return 9
		case 9:
			return 12
		}

	case PtMineiroClean, PtMineiroDirty:
		switch curPoint {
		case 2:
			return 4
		case 4:
			return 6
		case 6:
			return 10
		case 10:
			return 12
		}
	}
	return 0
}

// 决胜点数
func (t *PlayTypeConst) DecidingPoint() int {
	switch t.playType {
	case PtPaulistaClean:
		return 11
	case PtPaulistaDirty:
		return 11
	case PtMineiroClean:
		return 10
	case PtMineiroDirty:
		return 10
	default:
		return 0
	}
}
