package service

import (
	"fmt"
	"samba/pkg/servername"
	"samba/pkg/service"
	gs "samba/server/game/service"
	"samba/util/config"
)

type trucoService struct {
	service.IService
	AutoWaitStop bool // 旧服务，没人使用时自动关闭
}

var TrucoService trucoService

func (c trucoService) SendMsgToGate(uid int64, msgId string, msg interface{}) {
	gs.SendMsgToGate(c, uid, msgId, msg)
}

func (c trucoService) SendMsgToOther(srvName, routingKey string, uid int64, msgId string, msg interface{}) {
	gs.SendMsgToOther(TrucoService, srvName, routingKey, uid, msgId, msg)
}

func QueueName() string {
	return fmt.Sprintf("%v-%v", servername.Truco, config.Cmd.ChildId)
}

func SendMsg(exchange, routingKey string, roomId int, token string, uid int64, msgId string, msg interface{}) {
	gs.SendMsg(TrucoService, exchange, routingKey, roomId, token, uid, msgId, msg)
}

func SendMsgToDb(routingKey string, uid int64, msgId string, msg interface{}) {
	gs.SendMsgToDb(TrucoService, routingKey, uid, msgId, msg)
}

func SendMsgToOther(srvName, routingKey string, uid int64, msgId string, msg interface{}) {
	gs.SendMsgToOther(TrucoService, srvName, routingKey, uid, msgId, msg)
}

func SendMsgToGate(uid int64, msgId string, msg interface{}) {
	gs.SendMsgToGate(TrucoService, uid, msgId, msg)
}

func BroadcastMsg(msgId string, msg any) {
	gs.BroadcastMsg(TrucoService, msgId, msg)
}

var ParseMsg = gs.ParseMsg
