package model

import (
	"context"
	"github.com/go-redis/redis/v8"
	"samba/util/rdbkey"
	"strconv"
)

type ClubPermissionsOp struct {
	rdb *redis.Client
}

// 俱乐部管理员权限查询
func NewClubPermissionsOp() *ClubPermissionsOp {
	return &ClubPermissionsOp{rdb: rdbBaseInfo}
}

func (op *ClubPermissionsOp) Load(clubId int) []int {
	maps, _ := op.rdb.HGetAll(context.Background(), rdbkey.ClubPermissionsKey(clubId)).Result()
	if maps == nil {
		return []int{}
	}
	permissions := make([]int, 0)
	for k, v := range maps {
		permission, _ := strconv.Atoi(k)
		valid, _ := strconv.Atoi(v)
		if valid > 0 {
			permissions = append(permissions, permission)
		}
	}
	return permissions
}
