package model

import (
	"github.com/go-redis/redis/v8"
	"samba/pkg/log"
	"samba/stub"
	"samba/util/util"
)

type GlobalConfigAIOp struct {
	rdb *redis.Client
	key string
}

func NewGlobalAIConfigOp() *GlobalConfigAIOp {
	return &GlobalConfigAIOp{rdb: rdbConfig, key: "global_ai_config"}
}

func (t *GlobalConfigAIOp) Load() {
	var err error
	var g *stub.GlobalAI
	g, err = util.Redis2Struct[stub.GlobalAI](t.rdb, t.key)
	if err != nil {
		log.Error(err.Error())
		return
	}
	if g.TrucoLifeDays == 0 && g.TrucoMaxPlays == 0 {
		log.Warn("TrucoLifeDays and TrucoMaxPlays is 0, robot will not expiration")
	}

	stub.GGlobalAI = g
	return
}
