package model

import (
	"context"
	"fmt"
	"samba/pkg/log"
	"samba/util/rdbkey"
	"time"
)

func AddOnlineUser(userId int64) {
	ctx := context.Background()
	if userInfo, err := NewUserInfoOp().LoadFromRedis(userId); err == nil && userInfo != nil {
		err = rdbGameLog.HSet(ctx, rdbkey.OnlineUserKey(userInfo.API), userId, time.Now().Unix()).Err()
		if err != nil {
			log.Error(err.Error())
			return
		}
	} else {
		if err != nil {
			log.Error(err.Error())
		}
	}
}

func DelOnlineUser(userId int64) {
	ctx := context.Background()
	if userInfo, err := NewUserInfoOp().LoadFromRedis(userId); err == nil && userInfo != nil {
		err = rdbGameLog.HDel(ctx, rdbkey.OnlineUserKey(userInfo.API), fmt.Sprintf("%v", userId)).Err()
		if err != nil {
			log.Error(err.Error())
			return
		}
	} else {
		if err != nil {
			log.Error(err.Error())
		}
	}
}
