package util

import (
	"testing"
)

type BaseType struct {
	Uint    uint
	Uint8   uint8
	Uint16  uint16
	Uint32  uint32
	Uint64  uint64
	Int     int
	Int8    int8
	Int16   int16
	Int32   int32
	Int64   int64
	Float32 float32
	Float64 float64
	Byte    byte
	Bool    bool
	String  string
}

type Field struct {
	A int
	B string
}

type Array struct {
	Bytes   []byte
	Array   [3]int
	Strings []string
	Fields  []*Field
}

func TestSerialize(t *testing.T) {
	kv, err := Serialize(&BaseType{Int: 10, String: "name", Bool: true})
	if err != nil {
		t.Error(err)
		return
	}
	t.Log(kv)

	value := &Array{Bytes: []byte{1, 3, 3}, Array: [3]int{5, 5, 5},
		Strings: []string{"n1", "n2", "n3"}, Fields: []*Field{{A: 34, B: "f"}}}
	kv, err = Serialize(value)
	if err != nil {
		t.Error(err)
		return
	}
	t.Log(kv)

	value = &Array{}
	err = Deserialize(kv, value)
	if err != nil {
		t.Error(err)
		return
	}
	kv, err = Serialize(value)
	if err != nil {
		t.Error(err)
		return
	}
	t.Log(kv)
}
