package util

func Tie[T any](condition bool, t, f T) T {
	if condition {
		return t
	} else {
		return f
	}
}

func TieFn[T any, F ~func() T](cond bool, t, f F) T {
	if cond {
		return t()
	} else {
		return f()
	}
}

// TieOrFn 表达式为true时，返回t，否则执行f并返回执行结果
func TieOrFn[T any, F ~func() T](cond bool, t T, f F) T {
	if cond {
		return t
	} else {
		return f()
	}
}

func MakeMessage(msgId string, req interface{}, uid int64, roomId int) map[string]interface{} {
	msg := make(map[string]interface{})
	msg["r"] = roomId
	msg["a"] = msgId
	msg["uid"] = uid
	msg["p"] = req
	return msg
}
